#include "darwin_robot.h"
#include "darwin_robot_exceptions.h"

#include <iostream>

//std::string robot_device="A603LOBS";
std::string robot_device="A4008atn";

int main(int argc, char *argv[])
{
  int i=0;
  double accel_x,accel_y,accel_z;

  try{
    CDarwinRobot darwin("Darwin",robot_device,926100,0x02);
    std::cout << "found darwin controller" << std::endl;
    std::cout << "Number of calibration samples: " << darwin.imu_get_cal_samples() << std::endl;
    darwin.imu_start();
    for(i=0;i<50;i++)
    {
      darwin.imu_get_accel_data(&accel_x,&accel_y,&accel_z);
      std::cout << "Accel: x:" << accel_x << ", y: " << accel_y << ", z: " << accel_z << std::endl;
      usleep(100000);
    }
    darwin.imu_stop();
  }catch(CException &e){
    std::cout << e.what() << std::endl;
  }
}
