#include "darwin_robot.h"
#include "darwin_robot_exceptions.h"

#include <iostream>

std::string robot_device="A603LOBS";

int main(int argc, char *argv[])
{
  int num_v1_servos,num_v2_servos,i;
  std::vector<int> servos;
  std::vector<double> angles,speeds,accels;

  try{
    CDarwinRobot darwin("Darwin",robot_device,1000000,0xC0);
    darwin.mm_get_num_servos(&num_v1_servos,&num_v2_servos);
    std::cout << "Found " << num_v1_servos << " v1 servos and " << num_v2_servos << " v2 servos" << std::endl;
    darwin.mm_enable_power();
    for(i=0;i<=27;i++)
    {
      darwin.mm_enable_servo(i);
      darwin.mm_assign_module(i,DARWIN_MM_JOINTS);
    }
    darwin.mm_start();
    servos.push_back(22);
    servos.push_back(19);
    angles.push_back(45.0);
    angles.push_back(45.0);
    speeds.push_back(10.0);
    speeds.push_back(10.0);
    accels.push_back(10.0);
    accels.push_back(10.0);
    std::cout << "Start joint_motion ..." << std::endl;
    darwin.joints_load(servos,angles,speeds,accels);
    darwin.joints_start();
    while(darwin.are_joints_moving())
    {
      darwin.adc_get_data();
      angles=darwin.mm_get_servo_angles();
      for(i=0;i<angles.size();i++)
        std::cout << "servo " << i << ": " << angles[i] << std::endl;
      std::cout << "moving joints ..." << std::endl;
      usleep(100000);
    }
    std::cout << "done" << std::endl;
    return 0;
    servos.push_back(20);
    angles.clear();
    angles.push_back(0.0);
    angles.push_back(0.0);
    speeds.push_back(10.0);
    accels.push_back(10.0);
    darwin.joints_load(servos,angles,speeds,accels);
    darwin.joints_start();
    while(darwin.are_joints_moving())
    {
      angles=darwin.mm_get_servo_angles();
      std::cout << angles[19] << "," << angles[20] << std::endl;
      std::cout << "moving joints ..." << std::endl;
      usleep(100000);
    }
    darwin.mm_stop();
    darwin.mm_disable_power();
  }catch(CException &e){
    std::cout << e.what() << std::endl;
  }
}
